
#ifndef CP_Node_HEADER
#define CP_Node_HEADER

#include <string>

//	This class represents an "activity" of a project,
//	a.k.a. a node of a graph.
//
class Node {
	string name;
	int cost;
	bool has_prereqs;
public:
	Node(const string &n="", int c=0) : name(n), cost(c), has_prereqs(false) {}
	int getCost() const { return cost; }
	string getName() const { return name; }
	bool isStartNode() { return !has_prereqs; }
	void setStartNode(bool flag) { has_prereqs = !flag; }

	bool operator<(const Node& n) const { return name < n.name; }
	bool operator==(const Node& n) const { return name == n.name; }
	friend ostream &operator<<(ostream &os, const Node &n) {
		//os << "{name=" << n.name << ",cost=" << n.cost << "}";
		os << n.name << ": cost=" << n.cost;
	}
};

#endif CP_Node_HEADER
