
#ifndef CP_Path_HEADER
#define CP_Path_HEADER

#include <list>
#include <string>
#include <iostream>
#include "Node.h"

//	Path is a list of nodes,
//	with some features added for convenience.
//
class Path : public list<Node> {
	int total_cost;
	int calcCost();
	friend class Project;
public:
	Path() : total_cost(0) {}
	Path(Node &a, Node &b) {
		push_back(a);
		push_back(b);
	}
	Path(Node &a) {
		push_back(a);
	}
	int getCost() { return total_cost; }

	friend ostream &operator<<(ostream &os, const Path &p) {
		os << "total_cost=" << p.total_cost << "\n ";
		for (Path::const_iterator pi=p.begin(); pi!=p.end(); ++pi) {
			os << "(" << *pi << ") ";
		}
		return os;
	}
	bool operator<(const Path &p) {
		return total_cost < p.total_cost;
	}
#if 0
	bool operator>(const Path &p) {
		return total_cost > p.total_cost;
	}
#endif
	bool operator==(const Path &p) {
		return total_cost == p.total_cost;
	}
};

#endif CP_Path_HEADER
