
#ifndef CP_Project_HEADER
#define CP_Project_HEADER

#include <string>
#include <vector>
#include <map>
//#include <set>
#include "Path.h"
#include "Node.h"

//	This class represents a Project.
//
class Project {
	bool status;
	bool readfile(const string &fname);

	vector<Node> nodes;		// list of nodes (a.k.a. activities)
	typedef vector<Node>::iterator node_p;
	void createNode(const string &name, int cost);
	Node *findNode(const string &name);

	multimap<Node, Node> links;		// map of prereqs to goals
	typedef multimap<Node, Node>::iterator link_p;
	//multimap<string, string> links;
	//typedef multimap<string, string>::iterator link_p;

	vector<Path> paths;		// list of all paths for this project
	void addPath(Path &path);
	typedef list<Node> seen_type;
	vector<Path> getPathsFromNode(Node &, seen_type &seen);
	void makePaths();

	void error(const string &msg) const;
	void format_error(const string &msg, int lineno) const;

	vector<string> split(const string &s) const;
	string & stripSpaces(string & s) const;

public:
	Project(const string &filename);
	~Project();
	bool ok() { return status; } 
	operator bool() { return ok(); }
	//vector<Path> getPaths();
	//vector<Path> getCriticalPaths();
	void displayNodes();
	void displayLinks();
	void displayPaths();
	void displayCriticalPaths();
};

#endif CP_Project_HEADER
