
/*************************************************
*	This program determines the critical paths
*	for a set of related activities.
*	See README for more details.
***************************************************/

#include <iostream>
#include <string>
#include "Project.h"
#include "Path.h"
using namespace std;

main(int argc, char *argv[]) {

	try {
		string filename("input1.txt");
		if (argc > 1)
			filename = argv[1];

		Project p(filename);
		cout << "Project initialized\n\n";
		p.displayNodes();
		p.displayLinks();
		p.displayPaths();
		p.displayCriticalPaths();
	}
	catch (string emsg) {
		cerr << "Caught exception:\n";
		cerr << emsg << endl;
		exit(-1);
	}
	catch (...) {
		cerr << "caught unknown exception\n";
		exit(-1);
	}
}
